// ****************************************************************************************************
// File: Cells.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_CELLS
#define HURRICANE_CELLS

#include "hurricane/Collection.h"

namespace Hurricane {

class Cell;



// ****************************************************************************************************
// Cells declaration
// ****************************************************************************************************

typedef GenericCollection<Cell*> Cells;



// ****************************************************************************************************
// CellLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Cell*> CellLocator;



// ****************************************************************************************************
// CellFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Cell*> CellFilter;



// ****************************************************************************************************
// for_each_cell declaration
// ****************************************************************************************************

#define for_each_cell(cell, cells)\
/*********************************/\
{\
    CellLocator _locator = cells.getLocator();\
    while (_locator.isValid()) {\
        Cell* cell = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_CELLS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
