// ****************************************************************************************************
// File: DBos.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_DBOS
#define HURRICANE_DBOS

#include "hurricane/Collection.h"

namespace Hurricane {

class DBo;



// ****************************************************************************************************
// DBos declaration
// ****************************************************************************************************

typedef GenericCollection<DBo*> DBos;



// ****************************************************************************************************
// DBoLocator declaration
// ****************************************************************************************************

typedef GenericLocator<DBo*> DBoLocator;



// ****************************************************************************************************
// DBoFilter declaration
// ****************************************************************************************************

typedef GenericFilter<DBo*> DBoFilter;



// ****************************************************************************************************
// for_each_dbo declaration
// ****************************************************************************************************

#define for_each_dbo(dbo, dbos)\
/******************************/\
{\
    DBoLocator _locator = dbos.getLocator();\
    while (_locator.isValid()) {\
        DBo* dbo = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_DBOS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
