// ****************************************************************************************************
// File: Pathes.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_PATHES
#define HURRICANE_PATHES

#include "hurricane/Collection.h"
#include "hurricane/Path.h"

namespace Hurricane {



// ****************************************************************************************************
// Pathes declaration
// ****************************************************************************************************

typedef GenericCollection<Path> Pathes;



// ****************************************************************************************************
// PathLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Path> PathLocator;



// ****************************************************************************************************
// PathFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Path> PathFilter;



// ****************************************************************************************************
// for_each_path declaration
// ****************************************************************************************************

#define for_each_path(path, pathes)\
/**********************************/\
{\
	PathLocator _locator = pathes.getLocator();\
	while (_locator.isValid()) {\
		Path path = _locator.getElement();\
		_locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_PATHES

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
