// ****************************************************************************************************
// File: Points.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_POINTS
#define HURRICANE_POINTS

#include "hurricane/Collection.h"
#include "hurricane/Point.h"

namespace Hurricane {



// ****************************************************************************************************
// Points declaration
// ****************************************************************************************************

typedef GenericCollection<Point> Points;



// ****************************************************************************************************
// PointLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Point> PointLocator;



// ****************************************************************************************************
// PointFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Point> PointFilter;



// ****************************************************************************************************
// for_each_point declaration
// ****************************************************************************************************

#define for_each_point(point, points)\
/************************************/\
{\
	PointLocator _locator = points.getLocator();\
	while (_locator.isValid()) {\
		Point point = _locator.getElement();\
		_locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_POINTS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
